## jbigkit 2.0

=== libjbig/Makefile ===
# Unix makefile for the JBIG-KIT library
# $Id: Makefile 1285 2008-08-18 13:36:45Z mgk25 $

# Select an ANSI/ISO C compiler here, GNU gcc is recommended
CC = gcc

# Options for the compiler: A high optimization level is suggested
CFLAGS = -g -O -Wall -ansi -pedantic # --coverage

all: libjbig.a tstcodec tstcodec85

tstcodec: tstcodec.o jbig.o jbig_ar.o
	$(CC) $(CFLAGS) -o tstcodec $+

tstcodec85: tstcodec85.o jbig85.o jbig_ar.o
	$(CC) $(CFLAGS) -o tstcodec85 $+

libjbig.a: jbig.o jbig_ar.o
	rm -f libjbig.a
	ar rc libjbig.a jbig.o jbig_ar.o
	-ranlib libjbig.a

libjbig85.a: jbig85.o jbig_ar.o
	rm -f libjbig85.a
	ar rc libjbig85.a jbig85.o jbig_ar.o
	-ranlib libjbig85.a

jbig.o: jbig.c jbig.h jbig_ar.h
jbig85.o: jbig85.c jbig85.h jbig_ar.h
jbig_ar.o: jbig_ar.c jbig_ar.h
tstcodec.o: tstcodec.c jbig.h
tstcodec85.o: tstcodec85.c jbig85.h

jbig.pot: jbig.c
	xgettext -o$@ -k_ \
	  --copyright-holder='Markus Kuhn' \
	  --msgid-bugs-address='http://www.cl.cam.ac.uk/~mgk25/jbigkit/' $+

test: tstcodec tstcodec85
	./tstcodec
	./tstcodec85

t82test.pbm: tstcodec
	./tstcodec $@

clean:
	rm -f *.{o,gcda,gcno,gcov} *~ core gmon.out dbg_d\=??.pbm t82test.pbm
	rm -f tstcodec tstcodec85

=== pbmtools/Makefile ===
# Unix makefile for the JBIG-KIT PBM tools
# $Id: Makefile 1293 2008-08-25 22:26:39Z mgk25 $

# Select an ANSI/ISO C compiler here, e.g. GNU gcc is recommended
CC = gcc

# Options for the compiler
CFLAGS = -g -Wall -ansi -pedantic -I../libjbig # --coverage

.SUFFIXES: .1 .5 .txt $(SUFFIXES)

all: pbmtojbg jbgtopbm pbmtojbg85 jbgtopbm85 \
	pbmtojbg.txt jbgtopbm.txt pbm.txt pgm.txt

pbmtojbg: pbmtojbg.o ../libjbig/libjbig.a
	$(CC) $(CFLAGS) -o pbmtojbg pbmtojbg.o -L../libjbig -ljbig

jbgtopbm: jbgtopbm.o ../libjbig/libjbig.a
	$(CC) $(CFLAGS) -o jbgtopbm jbgtopbm.o -L../libjbig -ljbig

pbmtojbg85: pbmtojbg85.o ../libjbig/libjbig85.a
	$(CC) $(CFLAGS) -o pbmtojbg85 pbmtojbg85.o -L../libjbig -ljbig85

jbgtopbm85: jbgtopbm85.o ../libjbig/libjbig85.a
	$(CC) $(CFLAGS) -o jbgtopbm85 jbgtopbm85.o -L../libjbig -ljbig85

jbgtopbm.o: jbgtopbm.c ../libjbig/jbig.h
pbmtojbg.o: pbmtojbg.c ../libjbig/jbig.h
jbgtopbm85.o: jbgtopbm85.c ../libjbig/jbig85.h
pbmtojbg85.o: pbmtojbg85.c ../libjbig/jbig85.h

../libjbig/libjbig.a: ../libjbig/jbig.c ../libjbig/jbig.h \
	../libjbig/jbig_ar.c ../libjbig/jbig_ar.h
	make -C ../libjbig libjbig.a

../libjbig/libjbig85.a: ../libjbig/jbig85.c ../libjbig/jbig85.h \
	../libjbig/jbig_ar.c ../libjbig/jbig_ar.h
	make -C ../libjbig libjbig85.a

test: test82 test85

test82: pbmtojbg jbgtopbm
	make IMG=ccitt1     OPTIONSP=                      dotest1
	make IMG=ccitt2     OPTIONSP=                      dotest1
	make IMG=ccitt3     OPTIONSP=                      dotest1
	make IMG=xvlogo    "OPTIONSP=-d 3"                 dotest1
	make IMG=sandra     OPTIONSP=      OPTIONSJ=       dotest2g
	make IMG=sandra     OPTIONSP=-b    OPTIONSJ=-b     dotest2g
	make IMG=sandra     OPTIONSP=-q    OPTIONSJ=       dotest2g
	make IMG=sandra    "OPTIONSP=-o 0" OPTIONSJ=       dotest2g
	make IMG=sandra    "OPTIONSP=-o 2" OPTIONSJ=       dotest2g
	make IMG=multi      OPTIONSP=      OPTIONSJ=       dotest2g
	make IMG=multi      OPTIONSP=-b    OPTIONSJ=-b     dotest2g
	make IMG=mx        "OPTIONSP=-q -s 3 -m 128"       dotest1
	make IMG=mx        "OPTIONSP=-q -s 3 -m 128"       dotest2b
	make IMG=mx        "OPTIONSP=-q -s 3 -m 128 -p 92" dotest2b
	make IMG=mx        "OPTIONSP=-q -Y -1"             dotest2b
	make IMG=mx        "OPTIONSP=-Y -1"                dotest2b
	rm -f test-*.jbg test-*.pbm test-*.pgm
	./jbgtopbm ../examples/ccitt1.jbg | ./pbmtojbg > test-ccitt1.jbg
	cmp ../examples/ccitt1.jbg test-ccitt1.jbg
	rm -f test-*.jbg test-*.pbm test-*.pgm
	./jbgtopbm < ../examples/ccitt1.jbg | ./pbmtojbg - test-ccitt1.jbg
	cmp ../examples/ccitt1.jbg test-ccitt1.jbg
	rm -f test-*.jbg test-*.pbm test-*.pgm
	./jbgtopbm < ../examples/ccitt1.jbg - test-ccitt1.pbm ; \
	  ./pbmtojbg test-ccitt1.pbm test-ccitt1.jbg
	cmp ../examples/ccitt1.jbg test-ccitt1.jbg
	rm -f test-*.jbg test-*.pbm test-*.pgm
	./jbgtopbm ../examples/ccitt1.jbg test-ccitt1.pbm ; \
	  ./pbmtojbg test-ccitt1.pbm >test-ccitt1.jbg
	cmp ../examples/ccitt1.jbg test-ccitt1.jbg
	rm -f test-*.jbg test-*.pbm test-*.pgm
	@echo
	@echo "The pbmtools have PASSED the functional tests. Good!"
	@echo

dotest1:
	./jbgtopbm ../examples/$(IMG).jbg test-$(IMG).pbm
	./pbmtojbg $(OPTIONSP) test-$(IMG).pbm test-$(IMG).jbg
	cmp test-$(IMG).jbg ../examples/$(IMG).jbg

dotest2b:
	./pbmtojbg $(OPTIONSP) test-$(IMG).pbm test-$(IMG).jbg
	./jbgtopbm $(OPTIONSJ) test-$(IMG).jbg test-$(IMG)-2.pbm
	cmp test-$(IMG).pbm test-$(IMG)-2.pbm

dotest2g:
	./pbmtojbg $(OPTIONSP) ../examples/$(IMG).pgm test-$(IMG).jbg
	./jbgtopbm $(OPTIONSJ) test-$(IMG).jbg test-$(IMG).pgm
	cmp test-$(IMG).pgm ../examples/$(IMG).pgm

test85: pbmtojbg jbgtopbm pbmtojbg85 jbgtopbm85 test-t82.pbm
	make IMG=t82 "OPTIONSP=-p 0"      dotest85
	make IMG=t82 "OPTIONSP=-p 8"      dotest85
	make IMG=t82 "OPTIONSP=-p 8 -r"   dotest85b
	make IMG=t82 "OPTIONSP=-p 64"     dotest85
	make IMG=t82 "OPTIONSP=-p 72"     dotest85
	make IMG=t82 "OPTIONSP=-s 2 -C c" dotest85
	make IMG=t82 "OPTIONSP=-s 99999"  dotest85
	make IMG=t82 "OPTIONSP=-Y 9999 0" dotest85
	make IMG=t82 "OPTIONSP=-Y 1951 0" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 127" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 128" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 1919" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 1920" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 1949" dotest85
	make IMG=t82 "OPTIONSP=-Y -1 1950" dotest85
	make IMG=ccitt1 dotest85
	make IMG=ccitt2 dotest85
	make IMG=ccitt3 dotest85
	rm -f test-*.jbg test-*.jbg85 test-*.pbm
	@echo
	@echo "The T.85 pbmtools have PASSED the functional tests. Good!"
	@echo

dotest85: test-$(IMG).pbm
	./pbmtojbg85  $(OPTIONSP) test-$(IMG).pbm test-$(IMG).jbg85
	ls -l test-$(IMG).jbg85
	./jbgtopbm test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85
	rm test-$(IMG).pbm85
	./jbgtopbm85 test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85
	rm test-$(IMG).pbm85
	./jbgtopbm85 -B 1 test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85

dotest85b: test-$(IMG).pbm
	./pbmtojbg -f $(OPTIONSP) test-$(IMG).pbm test-$(IMG).jbg85
	ls -l test-$(IMG).jbg85
	./jbgtopbm test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85
	rm test-$(IMG).pbm85
	./jbgtopbm85 test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85
	rm test-$(IMG).pbm85
	./jbgtopbm85 -B 1 test-$(IMG).jbg85 test-$(IMG).pbm85
	cmp test-$(IMG).pbm test-$(IMG).pbm85

test-%.pbm: ../examples/%.jbg
	./jbgtopbm $< $@

test-t82.pbm:
	make -C ../libjbig tstcodec
	../libjbig/tstcodec $@

.1.txt .5.txt:
	groff -man -Tascii -P -c -P -b -P -u $< >$@

clean:
	rm -f *.o *~ core pbmtojbg jbgtopbm pbmtojbg85 jbgtopbm85
	rm -f test-*.jbg test-*.pbm test-*.pgm test-*.jbg85 test-*.pbm85
	rm -f *.gcda *.gcno

=== debian/changelog ===
jbigkit (2.0-2ubuntu4) trusty; urgency=low

  * libjbig0.symbols: Fix symbols file to refer to the right library.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 11 Dec 2013 02:14:44 -0700

jbigkit (2.0-2ubuntu3) trusty; urgency=low

  * Fix header include.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Dec 2013 19:25:40 +0100

jbigkit (2.0-2ubuntu2) trusty; urgency=medium

  * Allow the package to cross build, remove wrong libtool usage.
  * Build using hardening defaults.
  * Add a symbols file.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Dec 2013 19:00:45 +0100

jbigkit (2.0-2ubuntu1) quantal; urgency=low

  * Fix a number of compiler warnings per feedback from Ubuntu security team
    (LP: #993304).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 09 Jul 2012 11:57:58 +0100

jbigkit (2.0-2) unstable; urgency=low

  * Correct typo in new Makefile, so that libjbig.so now points to a file
    that exists (Closes: #667927)
  * Readd test target per Mathieu Malaterre's comments
  * Make test target work by forcing it to search the directory where the
    library was built.

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Sun, 08 Apr 2012 19:12:41 +1000

jbigkit (2.0-1) unstable; urgency=low

  * Initial release (Closes: #656413)

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Fri, 06 Apr 2012 07:05:15 +1000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
export DEB_HOST_MULTIARCH

CFLAGS ?= $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
LDFLAGS ?= $(shell dpkg-buildflags --get LDFLAGS)

ifneq ($(DEB_HOST_MULTIARCH),$(DEB_BUILD_MULTIARCH))
  CC = $(DEB_HOST_GNU_TYPE)-gcc
  export DEB_HOST_GNU_TYPE
else
  CC = cc
  unexport DEB_HOST_GNU_TYPE
endif

%:
	dh $@

pkg_run = jbigkit-bin

override_dh_auto_build:
	make CC="$(CC)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_installman:
	dh_installman -p$(pkg_run) debian/jbgtopbm85.1 debian/pbmtojbg85.1

debian/jbgtopbm85.1:
	help2man -n "reads a bi-level image entity (BIE) as input file" \
		--no-discard-stderr --output=debian/jbgtopbm85.1 --no-info jbgtopbm85

debian/pbmtojbg85.1:
	help2man -n "creates bi-level image entity (BIE) as output file" \
		--no-discard-stderr --output=debian/pbmtojbg85.1 --no-info pbmtojbg85

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://www.cl.cam.ac.uk/~mgk25/download/ \
	jbigkit-([\d\.]+).tar.gz

## jbigkit 2.1

=== libjbig/Makefile ===
# Unix makefile for the JBIG-KIT library

# Select an ANSI/ISO C compiler here, GNU gcc is recommended
CC = gcc

# Options for the compiler: A high optimization level is suggested
CFLAGS = -g -O -W -Wall -ansi -pedantic # --coverage

all: libjbig.a libjbig85.a tstcodec tstcodec85

tstcodec: tstcodec.o jbig.o jbig_ar.o
	$(CC) $(CFLAGS) -o tstcodec tstcodec.o jbig.o jbig_ar.o

tstcodec85: tstcodec85.o jbig85.o jbig_ar.o
	$(CC) $(CFLAGS) -o tstcodec85 tstcodec85.o jbig85.o jbig_ar.o

libjbig.a: jbig.o jbig_ar.o
	rm -f libjbig.a
	ar rc libjbig.a jbig.o jbig_ar.o
	-ranlib libjbig.a

libjbig85.a: jbig85.o jbig_ar.o
	rm -f libjbig85.a
	ar rc libjbig85.a jbig85.o jbig_ar.o
	-ranlib libjbig85.a

jbig.o: jbig.c jbig.h jbig_ar.h
jbig85.o: jbig85.c jbig85.h jbig_ar.h
jbig_ar.o: jbig_ar.c jbig_ar.h
tstcodec.o: tstcodec.c jbig.h
tstcodec85.o: tstcodec85.c jbig85.h

update-po: jbig.c jbig85.c Makefile
	xgettext -ojbig.pot -k_ \
	  --copyright-holder='Markus Kuhn' \
	  --msgid-bugs-address='http://www.cl.cam.ac.uk/~mgk25/jbigkit/' \
	  --package-name jbigkit \
	jbig.c jbig85.c
	cd po && for po in *.po ; do \
	  msgmerge --update $$po ../jbig.pot ; done

analyze:
	clang --analyze *.c

test: tstcodec tstcodec85
	./tstcodec
	./tstcodec85

t82test.pbm: tstcodec
	./tstcodec $@

clean:
	rm -f *.o *.gcda *.gcno *.gcov *.plist *~ core gmon.out dbg_d\=??.pbm
	rm -f t82test.pbm
	rm -f tstcodec tstcodec85

=== debian/changelog ===
jbigkit (2.1-6.1ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:00:28 +0200

jbigkit (2.1-6.1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/CVE-2017-9937.patch: set maximum decoded image size to
      2GB.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 May 2023 09:34:49 +0200

jbigkit (2.1-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix autopkgtest (Closes: #1023710)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 04 Dec 2022 19:16:16 +0100

jbigkit (2.1-6ubuntu1) lunar; urgency=medium

  * SECURITY UPDATE: abort when memory allocations fail in jbig.c
    - debian/patches/CVE-2017-9937.patch: set maximum decoded image size to
      2GB.
    - CVE-2017-9937

 -- Camila Camargo de Matos <camila.camargodematos@canonical.com>  Wed, 23 Nov 2022 08:17:10 -0300

jbigkit (2.1-6) unstable; urgency=medium

  * Rehome JBIGKit packaging onto salsa.debian.org
  * Fix up PIC release code which seems to render this unbuildable on ppc,
    hppa, and produces issues on mips(el)
  * Create testdata package
  * Add unit test

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Tue, 11 Oct 2022 10:46:00 +1100

jbigkit (2.1-5) unstable; urgency=medium

  [ Michael van der Kolff ]
  * Bump Compat to 13
  * Really update Std-Vers to 4.6.1 (it seems I typoed 4.5.1...)

  [ Christian Göttsche ]
  * Enable hardening flags and update Makefile patches to propagate them
  * misc Lintian cleanup

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Fri, 07 Oct 2022 16:23:00 +1100

jbigkit (2.1-4) unstable; urgency=medium

  * Use secure URI in Vcs control header (thanks, jelmer@!).
  * Add patch from upstream, closing serious bugs (Closes: #869708, #969593)
  * Bump Std-Vers to 4.6.1, no changes needed
  * Bump Compat to 12 - tests needed to be parallelisable
  * Fixed non-parallelised tests
  * Lintian-clean!

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Mon, 3 Oct 2022 16:43:00 +1100

jbigkit (2.1-3.1) unstable; urgency=medium

  * Non maintainer upload.
  * Allow the package to cross build, remove libtool usage. Closes: #761760.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Oct 2014 21:07:40 +0200

jbigkit (2.1-3) unstable; urgency=low

  * Fix up typo in man page
  * Correct makefile so that test targets use correct CFLAGS, too
  * Fix lintian pre-depends-directly-on-multiarch-support

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Fri, 25 Jul 2014 08:39:06 +1000

jbigkit (2.1-2) unstable; urgency=medium

  * Don't override passed CFLAGS in Makefile (so it now hardens properly)
  * Use -Wall, remove -Wno-unused-result (papering over #680935)
  * Fix remaining unused result warnings (Thanks Colin) (Closes: #680935)
  * Add static library to dev package (Closes: #741379)

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Wed, 23 Jul 2014 18:25:12 +1000

jbigkit (2.1-1) unstable; urgency=low

  * Bump Std-Vers to 3.9.5, no changes needed
  * Add symbols file (pulled from ubuntu diff) (Closes: #712240)
  * Remove explicit calls to `install -s`.
    Closes: #754344 (Thanks: Steve Langasek <steve.langasek@canonical.com>)
  * Update package priority (Closes: #755284)
  * Update watch location
  * Imported Upstream version 2.1

 -- Michael van der Kolff <mvanderkolff@gmail.com>  Sun, 20 Jul 2014 20:45:41 +1000

jbigkit (2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add CVE-2013-6369.patch patch.
    CVE-2013-6369: Fix stack-based buffer overflow flaw. (Closes: #743960)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 20 Apr 2014 16:37:42 +0200

=== debian/control ===
Source: jbigkit
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael van der Kolff <mvanderkolff@gmail.com>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.1
Section: libs
Homepage: http://www.cl.cam.ac.uk/~mgk25/jbigkit/
Vcs-Git: https://salsa.debian.org/debian-phototools-team/jbigkit.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/jbigkit
Rules-Requires-Root: no

Package: jbigkit-bin
Section: graphics
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: netpbm
Description: JBIGkit binaries
 JBIG-KIT provides a portable library of compression and decompression functions
 with a documented interface that you can include very easily into your image or
 document processing software.
 .
 This package contains the binaries from JBIG-KIT.

Package: jbigkit-testdata
Section: graphics
Architecture: any
Depends: ${misc:Depends}
Description: JBIG-KIT testdata
 JBIG-KIT provides a portable library of compression and decompression functions
 with a documented interface that you can include very easily into your image or
 document processing software.
 .
 This package contains the testdata included with JBIG-KIT.

Package: libjbig-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libjbig0 (= ${binary:Version}), ${misc:Depends}
Description: JBIGkit development files
 JBIG-KIT provides a portable library of compression and decompression functions
 with a documented interface that you can include very easily into your image or
 document processing software.
 .
 This package contains the headers for the library.
 .
 Please note: There is no statically linked library in this package, and what
 was previously two libraries with a single common file has been merged into
 one library (libjbig).

Package: libjbig0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JBIGkit libraries
 JBIG-KIT provides a portable library of compression and decompression functions
 with a documented interface that you can include very easily into your image or
 document processing software.
 .
 This package contains the dynamically linked library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -Wextra


%:
	dh $@

pkg_run = jbigkit-bin

override_dh_installman:
	dh_installman -p$(pkg_run) debian/jbgtopbm85.1 debian/pbmtojbg85.1

debian/jbgtopbm85.1:
	help2man -n "reads a bi-level image entity (BIE) as input file" \
		--no-discard-stderr --output=debian/jbgtopbm85.1 --no-info jbgtopbm85

debian/pbmtojbg85.1:
	help2man -n "creates bi-level image entity (BIE) as output file" \
		--no-discard-stderr --output=debian/pbmtojbg85.1 --no-info pbmtojbg85

get-orig-source:
	uscan --verbose --force-download --rename

## jbigkit 2.1.1

=== debian/changelog ===
jbigkit (2.1.1-1+rebuild) unstable; urgency=low

  * ['Autobuild release-candidate: 88f33772a44318883b7a934564d0e2ec3c7ae75b']

 -- shuttle <shuttle@deepin.com>  Tue, 10 Dec 2019 19:16:21 +0000
